//! Autogenerated weights for nomination
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2021-09-08, STEPS: `100`, REPEAT: 10, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("dev"), DB CACHE: 128

// Executed Command:
// target/release/interbtc-standalone
// benchmark
// --chain
// dev
// --execution=wasm
// --wasm-execution=compiled
// --pallet
// nomination
// --extrinsic
// *
// --steps
// 100
// --repeat
// 10
// --output
// crates/nomination/src/default_weights.rs
// --template
// .deploy/weight-template.hbs


#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]

use frame_support::{traits::Get, weights::{Weight, constants::RocksDbWeight}};
use sp_std::marker::PhantomData;

/// Weight functions needed for nomination.
pub trait WeightInfo {
	fn set_nomination_enabled() -> Weight;
	fn opt_in_to_nomination() -> Weight;
	fn opt_out_of_nomination() -> Weight;
	fn deposit_collateral() -> Weight;
	fn withdraw_collateral() -> Weight;
	fn set_nomination_limit() -> Weight;
}

/// Weights for nomination using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	// Storage: Nomination NominationEnabled (r:0 w:1)
	fn set_nomination_enabled() -> Weight {
		Weight::from_ref_time(2_835_000 as u64)
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:1)
	fn opt_in_to_nomination() -> Weight {
		Weight::from_ref_time(33_861_000 as u64)
			.saturating_add(T::DbWeight::get().reads(4 as u64))
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:1)
	// Storage: Staking Nonce (r:1 w:1)
	// Storage: Staking TotalCurrentStake (r:2 w:1)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Stake (r:2 w:1)
	// Storage: Staking SlashPerToken (r:2 w:0)
	// Storage: Staking SlashTally (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Staking RewardPerToken (r:2 w:1)
	// Storage: Staking TotalRewards (r:1 w:1)
	// Storage: Staking RewardTally (r:2 w:2)
	// Storage: Staking TotalStake (r:1 w:1)
	fn opt_out_of_nomination() -> Weight {
		Weight::from_ref_time(269_491_000 as u64)
			.saturating_add(T::DbWeight::get().reads(20 as u64))
			.saturating_add(T::DbWeight::get().writes(10 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: Staking Stake (r:2 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: VaultRegistry PremiumRedeemThreshold (r:1 w:0)
	// Storage: Rewards Stake (r:1 w:0)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards TotalRewards (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: System Account (r:1 w:0)
	fn deposit_collateral() -> Weight {
		Weight::from_ref_time(264_795_000 as u64)
			.saturating_add(T::DbWeight::get().reads(23 as u64))
			.saturating_add(T::DbWeight::get().writes(10 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Rewards Stake (r:1 w:0)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards TotalRewards (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:1)
	// Storage: Staking Stake (r:1 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: System Account (r:1 w:0)
	fn withdraw_collateral() -> Weight {
		Weight::from_ref_time(259_690_000 as u64)
			.saturating_add(T::DbWeight::get().reads(21 as u64))
			.saturating_add(T::DbWeight::get().writes(10 as u64))
	}
	// Storage: Nomination Nominationlimit (r:0 w:1)
	fn set_nomination_limit() -> Weight {
		Weight::from_ref_time(2_835_000 as u64)
			.saturating_add(T::DbWeight::get().writes(1 as u64))
	}
}

// For backwards compatibility and tests
impl WeightInfo for () {
	// Storage: Nomination NominationEnabled (r:0 w:1)
	fn set_nomination_enabled() -> Weight {
		Weight::from_ref_time(2_835_000 as u64)
			.saturating_add(RocksDbWeight::get().writes(1 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:1)
	fn opt_in_to_nomination() -> Weight {
		Weight::from_ref_time(33_861_000 as u64)
			.saturating_add(RocksDbWeight::get().reads(4 as u64))
			.saturating_add(RocksDbWeight::get().writes(1 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:1)
	// Storage: Staking Nonce (r:1 w:1)
	// Storage: Staking TotalCurrentStake (r:2 w:1)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Stake (r:2 w:1)
	// Storage: Staking SlashPerToken (r:2 w:0)
	// Storage: Staking SlashTally (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Staking RewardPerToken (r:2 w:1)
	// Storage: Staking TotalRewards (r:1 w:1)
	// Storage: Staking RewardTally (r:2 w:2)
	// Storage: Staking TotalStake (r:1 w:1)
	fn opt_out_of_nomination() -> Weight {
		Weight::from_ref_time(269_491_000 as u64)
			.saturating_add(RocksDbWeight::get().reads(20 as u64))
			.saturating_add(RocksDbWeight::get().writes(10 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: Staking Stake (r:2 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: VaultRegistry PremiumRedeemThreshold (r:1 w:0)
	// Storage: Rewards Stake (r:1 w:0)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards TotalRewards (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: System Account (r:1 w:0)
	fn deposit_collateral() -> Weight {
		Weight::from_ref_time(264_795_000 as u64)
			.saturating_add(RocksDbWeight::get().reads(23 as u64))
			.saturating_add(RocksDbWeight::get().writes(10 as u64))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Nomination NominationEnabled (r:1 w:0)
	// Storage: Nomination Vaults (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:0)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Rewards Stake (r:1 w:0)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards TotalRewards (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:1)
	// Storage: Staking Stake (r:1 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: System Account (r:1 w:0)
	fn withdraw_collateral() -> Weight {
		Weight::from_ref_time(259_690_000 as u64)
			.saturating_add(RocksDbWeight::get().reads(21 as u64))
			.saturating_add(RocksDbWeight::get().writes(10 as u64))
	}
	// Storage: Nomination NominationLimit (r:0 w:1)
	fn set_nomination_limit() -> Weight {
		Weight::from_ref_time(2_835_000 as u64)
			.saturating_add(RocksDbWeight::get().writes(1 as u64))
	}
}

